/* @BD_EJ1_preg_1.sql */
SET ECHO ON

SET SERVEROUTPUT ON
SET LINESIZE 132
SET PAGESIZE 200

column A1 format A2
column A2 format 9
column A3 format A2
column A4 format 9

/* producto cartesiano de R1 y R2
*/
SELECT * FROM R1, R2;

SELECT * FROM R1 CROSS JOIN R2;

SELECT * FROM R1, R2 ORDER BY A1, A2, R1.A3, A4;

SELECT * FROM R1 CROSS JOIN R2 ORDER BY A1, A2, R1.A3, A4;

/* JOIN de R1 y R2
*/
SELECT * FROM R1 INNER JOIN R2 ON (R1.A3 = R2.A3) ORDER BY A1, A2, R1.A3, A4;
SELECT * FROM R1 INNER JOIN R2 USING (A3) ORDER BY A1, A2, A3, A4;

SELECT * FROM R1 NATURAL JOIN R2 ORDER BY A1, A2, A3, A4;

SELECT A1, A2, A3, A4 FROM R1 NATURAL JOIN R2 ORDER BY A1, A2, A3, A4;

/* JOIN externo de R1 y R3 por la izquierda
*/
SELECT * FROM R1 LEFT OUTER JOIN R3 ON R1.A3 = R3.A3
 ORDER BY A1, A2, R1.A3, A4;

SELECT * FROM R1 LEFT OUTER JOIN R3 USING (A3)
 ORDER BY A1, A2, A3, A4;

SELECT * FROM R1, R3 WHERE R1.A3 = R3.A3(+)
 ORDER BY A1, A2, R1.A3, A4;

SELECT * FROM R3 RIGHT OUTER JOIN R1 USING (A3)
 ORDER BY A1, A2, A3, A4;

/* JOIN externo de R1 y R3 por la derecha
*/
SELECT * FROM R1 RIGHT OUTER JOIN R3 ON R1.A3 = R3.A3
 ORDER BY A1, A2, R1.A3, A4;

SELECT * FROM R1, R3 WHERE R1.A3(+) = R3.A3
 ORDER BY A1, A2, R1.A3, A4;

SELECT A1, A2, R1.A3, R3.A3, A4 FROM R3 LEFT OUTER JOIN R1 ON R1.A3 = R3.A3
 ORDER BY A1, A2, R1.A3, A4;

SELECT A1, A2, A3, A4 FROM R3 LEFT OUTER JOIN R1 USING (A3)
 ORDER BY A1, A2, A3, A4;

/* JOIN externo de R1 y R2 por la izquierda y la derecha
*/
SELECT * FROM R1 FULL OUTER JOIN R3 ON R1.A3 = R3.A3
 ORDER BY A1, A2, R1.A3, A4;

SELECT * FROM R1 FULL OUTER JOIN R3 USING (A3)
 ORDER BY A1, A2, A3, A4;

/* JOIN externo de R1 y R3 por la izquierda y la derecha (como en lgebra)
*/
SELECT A1, A2, A3, A4 FROM R1 NATURAL JOIN R3
UNION
SELECT A1, A2, A3, NULL AS A4 FROM R1 WHERE A3 NOT IN (SELECT A3 FROM R3)
UNION
SELECT NULL, NULL, A3, A4 FROM R3 WHERE A3 NOT IN (SELECT A3 FROM R1)
ORDER BY A1, A2, A3, A4;
 
SELECT A1, A2, A3, A4 FROM R1 NATURAL JOIN R3
UNION
SELECT A1, A2, R1.A3, A4 FROM R1 LEFT OUTER JOIN R3 ON R1.A3 = R3.A3 WHERE R3.A3 IS NULL
UNION
SELECT A1, A2, R3.A3, A4 FROM R1 RIGHT OUTER JOIN R3 ON R1.A3 = R3.A3 WHERE R1.A3 IS NULL
ORDER BY A1, A2, A3, A4;

SELECT A1, A2, A3, A4 FROM R1 NATURAL FULL OUTER JOIN R3
 ORDER BY A1, A2, A3, A4;
 
/* tuplas de R1 que no tienen correspondencia en R3
*/
SELECT * FROM R1 LEFT OUTER JOIN R3 ON R1.A3 = R3.A3
 WHERE R3.A3 IS NULL
 ORDER BY A1, A2, R1.A3, A4;

SELECT A1, A2, R1.A3 FROM R1 LEFT OUTER JOIN R3 ON R1.A3 = R3.A3
 WHERE R3.A3 IS NULL
 ORDER BY A1, A2, R1.A3;

SELECT * FROM R1 WHERE A3 NOT IN (SELECT A3 FROM R3)
 ORDER BY A1, A2, R1.A3;
